/*
 * @(#)SSOConfig.java
 *
 * Copyright (C) 2005 Infocity Inc. All Rights Reserved.
 */
package info.dragonlady.sso;

import info.dragonlady.cluster.Friend;
import info.dragonlady.sso.util.ResourceParseException;
import info.dragonlady.sso.util.ResourceUtils;

import java.util.ArrayList;
import java.util.List;

import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;


/**
 * VOTCI@\Ŏgpݒ胊\[XANZXNX
 * 
 * @author Hiroshi.Ebata(INFOCITY)
 * @version $Revision: 1.2 $ $Date: 2005/11/15 18:12:24 $
 */
public class SSOConfig {

	/**
	 * \[XpX
	 */
	private static final String resourcePath = "resources/sso_config.xml";

	/**
	 * voC_擾
	 * \[XIDɎgp
	 * 
	 * @return String voC_
	 * @throws ResourceParseException
	 */
	public static final String getProvider() throws ResourceParseException {
		String expression = "sso/provider";
		return ResourceUtils.getString(SSOConfig.resourcePath, expression);
	}

	/**
	 * AT[Vs擾
	 * 
	 * @return String AT[Vs
	 * @throws ResourceParseException
	 */
	public static final String getIssuer() throws ResourceParseException {
		String expression = "sso/issuer";
		return ResourceUtils.getString(SSOConfig.resourcePath, expression);
	}

	/**
	 * SAMLAT[VɊ܂߂鑮̃Xg擾
	 * 
	 * @return List<String> AT[VɊ܂߂鑮̃Xg
	 * @throws ResourceParseException
	 */
	public static final List<String> getSAMLAttributeList() throws ResourceParseException {
		String expression = "sso/saml_attribute/name";
		NodeList nodeList = ResourceUtils.getNodeSet(SSOConfig.resourcePath, expression);
		List<String> list = new ArrayList<String>();
		for(int i = 0; i < nodeList.getLength(); i++) {
			list.add(ResourceUtils.getTextContent(nodeList.item(i)));
		}
		return list;
	}

	/**
	 * AT[VLibj擾
	 * 
	 * @return Integer AT[VLibj
	 * @throws ResourceParseException
	 */
	public static final Integer getAssertionLife() throws ResourceParseException {
		String expression = "sso/assertion_life";
		return new Integer(ResourceUtils.getString(SSOConfig.resourcePath, expression));
	}

	/**
	 * F؃I[\eBNX擾B
	 * 
	 * @return String F؃I[\eBNX
	 * @throws ResourceParseException
	 */
	public static final String getAuthenticationAuthorityClass() throws ResourceParseException {
		String expression = "sso/authority/authentication-class";
		return ResourceUtils.getString(SSOConfig.resourcePath, expression);
	}

	/**
	 * I[\eBNX擾B
	 * 
	 * @return String I[\eBNX
	 * @throws ResourceParseException
	 */
	public static final String getAttributeAuthorityClass() throws ResourceParseException {
		String expression = "sso/authority/attribute-class";
		return ResourceUtils.getString(SSOConfig.resourcePath, expression);
	}

	/**
	 * |V[_NX擾B
	 * 
	 * @return String |V[_NX
	 * @throws ResourceParseException
	 */
	public static final String getPolicyDecisionPointClass() throws ResourceParseException {
		String expression = "sso/authority/policy-decision-class";
		return ResourceUtils.getString(SSOConfig.resourcePath, expression);
	}

	/**
	 * IDǗNX擾B
	 * 
	 * @return String IDǗNX
	 * @throws ResourceParseException
	 */
	public static final String getIDProviderClass() throws ResourceParseException {
		String expression = "sso/idprovider-class";
		return ResourceUtils.getString(SSOConfig.resourcePath, expression);
	}

	/**
	 * L[XgÃpX擾B
	 * 
	 * @return String L[XgÃpX
	 * @throws ResourceParseException
	 */
	public static final String getKeyStorePath() throws ResourceParseException {
		String expression = "sso/signature/keystore/path";
		return ResourceUtils.getString(SSOConfig.resourcePath, expression);
	}

	/**
	 * L[XgÃGCAX擾B
	 * 
	 * @return String L[XgÃGCAX
	 * @throws ResourceParseException
	 */
	public static final String getKeyStoreAlias() throws ResourceParseException {
		String expression = "sso/signature/keystore/alias";
		return ResourceUtils.getString(SSOConfig.resourcePath, expression);
	}

	/**
	 * L[XgÃpX[h擾B
	 * 
	 * @return String L[XgÃpX[h
	 * @throws ResourceParseException
	 */
	public static final String getKeyStorePassword() throws ResourceParseException {
		String expression = "sso/signature/keystore/password";
		return ResourceUtils.getString(SSOConfig.resourcePath, expression);
	}

	/**
	 * ؖ̃pX擾B
	 * 
	 * @return String ؖ̃pX
	 * @throws ResourceParseException
	 */
	public static final String getCertPath() throws ResourceParseException {
		String expression = "sso/signature/cert-path";
		return ResourceUtils.getString(SSOConfig.resourcePath, expression);
	}

	/**
	 * OCL[擾B
	 * 
	 * @return String OCL[
	 * @throws ResourceParseException
	 */
	public static final String getLoginKey() throws ResourceParseException {
		String expression = "sso/login-key";
		return ResourceUtils.getString(SSOConfig.resourcePath, expression);
	}

	/**
	 * G[̃_CNV擾B
	 * 
	 * @return String _CNV
	 * @throws ResourceParseException
	 */
	public static final String getRedirection() throws ResourceParseException {
		String expression = "sso/redirection";
		return ResourceUtils.getString(SSOConfig.resourcePath, expression);
	}

	/**
	 * T[oAgT[rXAhX擾B
	 * 
	 * @return String _CNV
	 * @throws ResourceParseException
	 */
	public static final String getCooperationService() throws ResourceParseException {
		String expression = "sso/cooperation-service";
		return ResourceUtils.getString(SSOConfig.resourcePath, expression);
	}

	/**
	 * X^hAœ삷邩ۂiNX^OsۂjB
	 * 
	 * @return boolean trueFX^hAiNX^OsȂj^falseFX^hAłȂiNX^Osj
	 * @throws ResourceParseException
	 */
	public static final boolean isClusterStandalone() throws ResourceParseException {
		String expression = "sso/cluster/@standalone";
		return Boolean.valueOf(ResourceUtils.getString(SSOConfig.resourcePath, expression)).booleanValue();
	}

	/**
	 * NX^OT[oIPAhX擾B
	 * 
	 * @return String NX^OT[oIPAhX
	 * @throws ResourceParseException
	 */
	public static final Friend[] getFriends() throws ResourceParseException {
		String expression = "ssocluster/friends_ip";
		NodeList list = ResourceUtils.getNodeSet(SSOConfig.resourcePath, expression);
		Friend[] friends = new Friend[list.getLength()];
		for(int i = 0; i < list.getLength(); i++) {
			Node node = list.item(i);
			NamedNodeMap paramMap = node.getAttributes();
			String host = paramMap.getNamedItem("host").getNodeValue();
			String port = paramMap.getNamedItem("port").getNodeValue();
			Friend friend = new Friend();
			friend.setHost(host);
			friend.setPort(port);
			friends[i] = friend;
		}
		return friends;
	}

	/**
	 * RMIT[rX擾B
	 * 
	 * @param ipAddress IPAhX
	 * @param port |[gԍ
	 * @param serviceName T[rX
	 * @return String [UǗT[rX
	 */
	public static final String getServiceName(String ipAddress, String port, String serviceName) {
		StringBuffer name = new StringBuffer();
		name.append("//");
		name.append(ipAddress);
		name.append(":");
		name.append(port);
		name.append("/");
		name.append(serviceName);
		return name.toString();
	}

}
